/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 11.9 (Uniform-Spacings, p. 257)
 *
 * this file: algo11_09.c
 *
 * For a demo how to use this algorithm see the file "demo_algo11_10.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"

void generator11_09(int d, double s[])
/* 
 * Algorithm 11.9 (Uniform-Spacings, p. 257)
 * generates uniform spacings (S_1, S_2, ... S_d+1)
 * d+1 ... length of the generated vectors
 * s ... is the array to hold the generated vector     
 */
{     int i;
      double e; 

      e=0;
      for(i=1;i<=d+1;i++){
/*1*/	s[i]=-log(1.-uniform());
/*2*/	e+=s[i];
      }
/*3*/ for(i=1;i<=d+1;i++) s[i]/=e;
}



